package org.dromara.knowledge.service;

import com.baomidou.mybatisplus.extension.service.IService;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.knowledge.domain.KnowledgeSchema;
import org.dromara.knowledge.domain.bo.KnowledgeSchemaBo;
import org.dromara.knowledge.domain.vo.KnowledgeSchemaVo;

import java.util.Collection;
import java.util.List;

/**
 * 知识库数据模型Service接口
 *
 * @author pengles
 */
public interface KnowledgeSchemaService extends IService<KnowledgeSchema> {

    /**
     * 查询知识库模式
     */
    KnowledgeSchemaVo queryById(Long id);

    /**
     * 查询知识库模式列表
     */
    TableDataInfo<KnowledgeSchemaVo> queryPageList(KnowledgeSchemaBo bo, PageQuery pageQuery);

    /**
     * 查询知识库模式列表
     */
    List<KnowledgeSchemaVo> queryList(KnowledgeSchemaBo bo);

    /**
     * 新增知识库模式
     */
    Boolean insertByBo(KnowledgeSchemaBo bo);

    /**
     * 修改知识库模式
     */
    Boolean updateByBo(KnowledgeSchemaBo bo);

    /**
     * 校验并批量删除知识库模式
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 根据模式组ID查询模式列表
     */
    List<KnowledgeSchemaVo> queryListBySchemaGroupId(Long schemaGroupId);

    /**
     * 根据编码查询模式信息
     */
    KnowledgeSchemaVo queryByCode(String code);

    /**
     * 根据表名查询模式信息
     */
    KnowledgeSchemaVo queryByTableName(String tableName);
}